require("socket")
require("task")
local message = "Hello Server!"
local host, port = "127.0.0.1", 1234

local tcp = nil
local name = nil

function initTcpIp()
	host, port = "127.0.0.1", 1234
	tcp = assert(socket.tcp())
	tcp:settimeout(0)
	tcp:connect(host, port);
end

function initInputHandler ()
	local tsk = task.create ("inputhandler.lua", {task.id()})
	if tsk == -1 then
		io.stdout:write( "-> Can't expand task list.\n" )
	elseif tsk == -2 then
		io.stdout:write( "-> Can't strdup file name.\n" )
	elseif tsk == -3 then
		io.stdout:write( "-> Can't create message queue.\n" )
	elseif tsk == -4 then
		io.stdout:write( "-> Can't create os thread.\n" )
	elseif tsk == -11 then
		io.stdout:write( "-> The library seems corrupt.\n" )
	else
		io.stdout:write( "-> Task ", tsk, " started.\n" )
	end
end

function readInput()
	local buf, _, _ = task.receive( -0 )
	return buf
end

function main()
	while name == nil do
		print ("What is Your name?")
		name = io.read()
	end
	initTcpIp()
	initInputHandler()
	-- authenticating
	tcp:send(name .. '\n')

	local line, err, partial_line
	while true do
		message = readInput()
		if message ~= nil then
			print (" me > " .. message)
			tcp:send(message .. "\n");
		end
		line, err, partial_line = tcp:receive()
		-- if there is no problem then status should be nill
		-- status can also be "closed" or "timoout"
		if not err then
			print((line or partial_line))
		elseif err ~= "timeout" then
			print ("connection " .. err)
			break
		end

	end
	tcp:close()
end

main()

