require("socket")
-- create a TCP socket and bind it to the local host, at any port
-- local server = assert(socket.bind("*", 0))
local message = "usage:\n\t\\s - select a user to chat with\n\t\\l - list of all available user"
local server = nil
local ip, port = nil, nil

local clientsAndCoros = {}
local members = {}

function handleClient(client)
	local line, err
	local partner = nil
	local partnerSocket = nil
	local name = nil


	-- firs message should be the name of the user
	while true do
		name, err = client:receive()
		if name ~= nil then
			if name == "" then
				client:send("Your user name can not be empty" .. "\n")
				clientsAndCoros[client] = nil
				client:close()
				return
			elseif members[name] == nil then
				members[name] = client
				print (name .. " has come online")
				break
			end
		end
		client:send("This username is already in use" .. "\n")
		clientsAndCoros[client] = nil
		client:close()
		return
	end

	client:settimeout(0)


	while 1 do
		-- receive the line
		line, err = client:receive()
		-- if there was no error, send it back to the client
		if not err then
			--print (" in  << " .. line)
			if string.sub(line, 1,2) == "\\c" then
				partner = string.sub(line, 4)
				if partner == name then
					client:send("You cannot connect to your self" .. "\n")
					partner = nil
				end
			elseif string.sub(line, 1,2) == "\\l" then
				for member_name, _ in pairs(members) do
					if member_name ~= name then
						client:send(member_name .. "\n")
					end
				end
			else
				if partner ~= nil and members[partner] ~= nil then
					members[partner]:send(" " .. name .. " > " .. line .. "\n")
					--partnerSocket  = members[partner]
					--partnerSocket:send(name .. "> " .. line .. "\n")
				else
					client:send("You do not have a partner or your partner has disconnected recently\n" .. message .. "\n")
				end
			end
		elseif err ~= "timeout" then
			break
		end
		coroutine.yield()
	end
	print ("connection " .. err)
	clientsAndCoros[client] = nil
	client:close()
	members[name] = nil
	print (name .. " has gone offline")
end


function initTcpIp()
	server = assert(socket.bind("*", 1234))
	ip, port = server:getsockname()
	server:settimeout(0)
end

function main()
	initTcpIp()
	print("Please connect the client to localhost on port " .. port)
	while 1 do
		local client = server:accept()
		if client ~= nil then
			--print ("A client has connected")
			local coro = coroutine.create(handleClient)
			clientsAndCoros[client] = coro
		end

		for iClient ,iCoro in pairs (clientsAndCoros) do
			coroutine.resume(iCoro, iClient)
		end

		local nConnection = 0
		for iClient ,iCoro in pairs (clientsAndCoros) do
			nConnection = nConnection + 1
		end
		--print ("nConnection: " .. nConnection)

	end

end

main()
